<template>
    <div class="list-view">
        <div class="filters-container">
            <!-- <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input> -->
            <el-select class="filter-item" v-model="districtId" clearable>
                <el-option v-for="item in district" :key="item.id" :value="item.name" :label="item.name"></el-option>
            </el-select>
            <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">查询 </el-button>
            <!-- <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button> -->
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <!-- <el-table-column prop="id" label="ID" width="100"> </el-table-column> -->
            <el-table-column prop="organizer" label="承办单位"> </el-table-column>
            <el-table-column prop="district" label="通讯地址"> </el-table-column>
            <el-table-column prop="privacyPolicy" label="法人姓名"> </el-table-column>
            <el-table-column prop="idno" label="证件号码"> </el-table-column>
            <el-table-column prop="examinationAgency" label="所属考级机构"> </el-table-column>
            <el-table-column prop="recordTime" label="备案时间"> </el-table-column>
            <el-table-column prop="supervisorNickname" label="监管人员"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" min-width="80">
                <template slot-scope="{ row }">
                    <el-button @click="supervision(row.id)" type="primary" size="mini" plain>分配监管人</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
        <el-dialog title="分配监管人" :visible.sync="dialogVisible" width="500px" center>
            <div>
                <el-table :data="supervisor">
                    <el-table-column prop="nickname" label="昵称"></el-table-column>
                    <el-table-column prop="phone" label="手机号"></el-table-column>
                    <el-table-column label="操作" align="center" fixed="right" min-width="80">
                        <template slot-scope="{ row }">
                            <el-button @click="addRegulatory(row.id)" type="success" size="mini" plain>确认</el-button>
                        </template>
                    </el-table-column>
                </el-table>
            </div>
        </el-dialog>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'RecordList',
    mixins: [pageableTable],
    created() {
        this.$http
            .get('/district/NJ')
            .then(res => {
                this.district = res;
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    mounted() {
        this.$http
            .post('/user/authority', { authorityName: 'ROLE_SUPERVISOR' })
            .then(res => {
                this.supervisor = res;
                // if (res.length > 0) {
                //     res.forEach(item => {
                //         this.supervisor.push({
                //             label: item.nickname,
                //             value: item.id
                //         });
                //     });
                // }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/record/allDTO',
            downloading: false,
            district: [],
            districtId: '',
            supervisor: [],
            dialogVisible: false,
            recordId: ''
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        categoryFormatter(row, column, cellValue, index) {
            let selectedOption = this.categoryOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        statusFormatter(row, column, cellValue, index) {
            let selectedOption = this.statusOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            return {
                search: this.search,
                sort: 'recordTime,desc',
                query: {
                    district: '玄武区',
                    del: false
                }
            };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/recordEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/recordEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/record/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/record/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        distribute() {
            this.$alert('已分发到各区县！', '分发', {
                confirmButtonText: '确定'
            });
        },
        update() {
            this.$http
                .get('/record/update')
                .then(res => {
                    this.getData();
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        },
        supervision(id) {
            this.dialogVisible = true;
            this.recordId = id;
        },
        addRegulatory(id) {
            this.$http
                .post('/record/addSupervisor', {
                    id: this.recordId,
                    userId: id
                })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.dialogVisible = false;
                    this.recordId = '';
                    this.getData();
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
